*/

This test code just stops and then starts an NT service programatically.
To incorperate this code into your project, just copy and paste the relevant
part (stop or staart section) into your source code. For stopping, you will need to do
something with the printf() may be a pop up and you *will* have to deal with any failures.

*/





#include <conio.h>
#include <stdio.h>

#include <windows.h>
#include <winsvc.h>

char *service_name = "My_Service"; /* change this to suite your service */


int main ( void )
{
	SC_HANDLE service_manager, service_handle;
	SERVICE_STATUS service_status;
	long result;

	service_manager = OpenSCManager( NULL, NULL, SC_MANAGER_CONNECT );
	if ( service_manager == NULL )
		result = GetLastError ();
	if ( result != 120 && service_manager != NULL )
	{
		service_handle = OpenService( service_manager,
			service_name,  /* the registerd service name
	                      could be different from the
                        displayed name */
			SERVICE_ALL_ACCESS );
		if ( service_handle == NULL )
		{
			printf ( "Failed to get a handle on SDC-Launcher\n\n" );
			result = GetLastError ();
			switch ( result )
			{
			case ERROR_ACCESS_DENIED:
				printf ( "The specified service control manager database handle\n"
					    "does not have access to the service." );
				break;

			case ERROR_INVALID_HANDLE:
				printf (	"The specified handle is invalid." );
				break;

			case ERROR_INVALID_NAME:
				printf ( "The specified service name is invalid." );
				break;

			case ERROR_SERVICE_DOES_NOT_EXIST:
				printf ( "The specified service does not exist." );
				break;

			default:
				printf ( "Unknown error #%u", result );
				break;
			}
			printf ( "\n\nPress any key." );
			while ( _kbhit () == 0 );
			return 1;
		}
		ControlService( service_handle, SERVICE_CONTROL_STOP, &service_status );
		while ( service_status.dwCurrentState != SERVICE_STOPPED )
		{
			Sleep ( 100 );
			QueryServiceStatus( service_handle, &service_status );
		}
	}
	else
	{
		printf ( "Failed on \"OpenSCManager\"\nPress any key\n" );
		while ( _kbhit () == 0 );
		return 1;
	}



	printf ( "Service stopped\n" );
	printf ( "Check the service manager.\nPress any key\n" );
	while ( _kbhit () == 0 );
  /* return 0; */

	StartService ( service_handle,
		0,
		NULL );
	printf ( "Service started\n" );
	printf ( "Check the service manager.\nPress any key\n" );
	while ( _kbhit () == 0 );
	return 0;
}
